import React from 'react';
export declare type IonFormItemOptions<T extends object, K extends keyof T, E extends CustomEvent> = {
    state: T;
    setState: (state: T) => void;
    name: K;
    label?: string;
    renderContent: (props: {
        name: string;
        onIonChange: (e: any) => void;
        value?: T[K];
        checked?: boolean;
    }) => JSX.Element;
    mapValue?: (e: E, currentValue: T[K]) => T[K];
    renderLabel?: typeof IonFormItemOptions.Label;
};
export declare function IonFormItem<T extends object, K extends keyof T, E extends CustomEvent>(props: IonFormItemOptions<T, K, E>): JSX.Element;
export declare let IonFormItemOptions: {
    Label: (props: {
        label?: string | undefined;
        name: PropertyKey;
    }) => JSX.Element;
};
export declare type UseIonFormItemOptions<T extends object, K extends keyof T, E extends CustomEvent> = {
    name: K;
    label?: string;
    renderContent: (props: {
        onIonChange: (e: any) => void;
        value?: T[K];
        checked?: boolean;
    }) => JSX.Element;
    mapValue?: (event: E, currentValue: T[K]) => T[K];
    renderLabel?: typeof IonFormItemOptions.Label;
};
export declare function useIonFormState<T extends object>(initialValue?: T): {
    state: T;
    setState: React.Dispatch<React.SetStateAction<T>>;
    reset: () => void;
    item<K extends keyof T, E extends CustomEvent<any>>(props: UseIonFormItemOptions<T, K, E>): JSX.Element;
};
